%define anolis_release 5
%bcond_without devel
%define soversion 1.1
%global _performance_build 1
%define real_name OpenSSL

Summary: Compatibility version of the OpenSSL library
Name: openssl1.1
Version: 1.1.1q
Release: %{anolis_release}%{?dist}
Epoch: 1
License: OpenSSL and ASL 2.0
URL: http://www.openssl.org/
Source: %{url}/source/openssl-%{version}.tar.gz
Source1: hobble-openssl
Source2: ec_curve.c
Source3: ectest.c

BuildRequires: make, gcc > 12.0
BuildRequires: coreutils
BuildRequires: perl-interpreter
BuildRequires: sed
BuildRequires: /usr/bin/cmp, /usr/bin/rename, /usr/bin/pod2man, /usr/sbin/sysctl
BuildRequires: zlib-devel
BuildRequires: lksctp-tools-devel
BuildRequires: perl(Test::Harness)
BuildRequires: perl(Test::More)
BuildRequires: perl(Math::BigInt)
BuildRequires: perl(Module::Load::Conditional)
BuildRequires: perl(File::Temp)
BuildRequires: perl(Time::HiRes)
BuildRequires: perl(FindBin)
BuildRequires: perl(lib)
BuildRequires: perl(File::Compare)
BuildRequires: perl(File::Copy)
Conflicts: openssl-libs < 1:3.0

Patch1001: openssl-1.1.1-build.patch
Patch1002: openssl-1.1.1-defaults.patch
Patch1003: openssl-1.1.1-no-html.patch
Patch1004: openssl-1.1.1-man-rename.patch

Patch1031: openssl-1.1.1-conf-paths.patch
Patch1032: openssl-1.1.1-version-add-engines.patch
Patch1033: openssl-1.1.1-apps-dgst.patch
Patch1036: openssl-1.1.1-no-brainpool.patch
Patch1037: openssl-1.1.1-ec-curves.patch
Patch1038: openssl-1.1.1-no-weak-verify.patch
Patch1040: openssl-1.1.1-disable-ssl3.patch
Patch1041: openssl-1.1.1-system-cipherlist.patch
Patch1042: openssl-1.1.1-fips.patch
Patch1044: openssl-1.1.1-version-override.patch
Patch1045: openssl-1.1.1-weak-ciphers.patch
Patch1046: openssl-1.1.1-seclevel.patch
Patch1047: openssl-1.1.1-ts-sha256-default.patch
Patch1048: openssl-1.1.1-fips-post-rand.patch
Patch1049: openssl-1.1.1-evp-kdf.patch
Patch1050: openssl-1.1.1-ssh-kdf.patch
Patch1051: openssl-1.1.1-intel-cet.patch
Patch1060: openssl-1.1.1-krb5-kdf.patch
Patch1061: openssl-1.1.1-edk2-build.patch
Patch1062: openssl-1.1.1-fips-curves.patch
Patch1065: openssl-1.1.1-fips-drbg-selftest.patch
Patch1066: openssl-1.1.1-fips-dh.patch
Patch1067: openssl-1.1.1-kdf-selftest.patch
Patch1069: openssl-1.1.1-alpn-cb.patch
Patch1070: openssl-1.1.1-rewire-fips-drbg.patch
Patch1071: add-loongarch64-support-for-openssl1.1.1q.patch

Patch1052: openssl-1.1.1-s390x-update.patch
Patch1053: openssl-1.1.1-fips-crng-test.patch
Patch1055: openssl-1.1.1-arm-update.patch
Patch1056: openssl-1.1.1-s390x-ecc.patch

%description
The %{real_name} toolkit provides support for secure communications between
machines. This version of %{real_name} package contains only the libraries
from the 1.1.1 version and is provided for compatibility with previous
releases.

%if %{with devel}
%package devel
Summary: Files for development of applications which will use %{real_name}
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: pkgconfig
Conflicts: openssl-devel

%description devel
%{real_name} is a toolkit for supporting cryptography. The openssl-devel
package contains include files needed to develop applications which
support various cryptographic algorithms and protocols.
%endif

%package doc
Summary: Doc files for %{real_name}
Requires: %{name} = %{epoch}:%{version}-%{release}
BuildArch: noarch

%description doc
Doc files for %{real_name}

%prep
%setup -q -n openssl-%{version}

%{SOURCE1} > /dev/null

cp %{SOURCE2} crypto/ec/
cp %{SOURCE3} test/

%patch1001 -p1 -b .build   %{?_rawbuild}
%patch1002 -p1 -b .defaults
%patch1003 -p1 -b .no-html  %{?_rawbuild}
%patch1004 -p1 -b .man-rename

%patch1031 -p1 -b .conf-paths
%patch1032 -p1 -b .version-add-engines
%patch1033 -p1 -b .dgst
%patch1036 -p1 -b .no-brainpool
%patch1037 -p1 -b .curves
%patch1038 -p1 -b .no-weak-verify
%patch1040 -p1 -b .disable-ssl3
%patch1041 -p1 -b .system-cipherlist
%patch1042 -p1 -b .fips
%patch1044 -p1 -b .version-override
%patch1045 -p1 -b .weak-ciphers
%patch1046 -p1 -b .seclevel
%patch1047 -p1 -b .ts-sha256-default
%patch1048 -p1 -b .fips-post-rand
%patch1049 -p1 -b .evp-kdf
%patch1050 -p1 -b .ssh-kdf
%patch1051 -p1 -b .intel-cet
%patch1052 -p1 -b .s390x-update
%patch1053 -p1 -b .crng-test
%patch1055 -p1 -b .arm-update
%patch1056 -p1 -b .s390x-ecc
%patch1060 -p1 -b .krb5-kdf
%patch1061 -p1 -b .edk2-build
%patch1062 -p1 -b .fips-curves
%patch1065 -p1 -b .drbg-selftest
%patch1066 -p1 -b .fips-dh
%patch1067 -p1 -b .kdf-selftest
%patch1069 -p1 -b .alpn-cb
%patch1070 -p1 -b .rewire-fips-drbg
%patch1071 -p1


%build
sslarch=%{_os}-%{_target_cpu}
%ifarch x86_64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch aarch64
sslarch=linux-aarch64
sslflags=enable-ec_nistp_64_gcc_128
%endif
%ifarch riscv64
sslarch=linux-generic64
sslflags="--libdir=%{_libdir}"
%endif

RPM_OPT_FLAGS="$RPM_OPT_FLAGS -Wa,--noexecstack -Wa,--generate-missing-build-notes=yes -DPURIFY $RPM_LD_FLAGS"

export HASHBANGPERL=/usr/bin/perl

./Configure \
	--prefix=%{_prefix} \
	--openssldir=%{_sysconfdir}/pki/tls ${sslflags} \
	--system-ciphers-file=%{_sysconfdir}/crypto-policies/back-ends/openssl.config \
	zlib \
	enable-camellia \
	enable-seed \
	enable-rfc3779 \
	enable-sctp \
	enable-cms \
	enable-md2 \
	enable-rc5 \
	enable-ssl3 \
	enable-ssl3-method \
	enable-weak-ssl-ciphers \
	no-mdc2 \
	no-ec2m \
	no-sm2 \
	no-sm4 \
	shared  ${sslarch} $RPM_OPT_FLAGS '-DDEVRANDOM="\"/dev/urandom\""'

make all

for i in libcrypto.pc libssl.pc openssl.pc ; do
  sed -i '/^Libs.private:/{s/-L[^ ]* //;s/-Wl[^ ]* //}' $i
done

%check

(sysctl net.sctp.addip_enable=1 && sysctl net.sctp.auth_enable=1) || \
(echo 'Failed to enable SCTP AUTH chunks, disabling SCTP for tests...' &&
 sed '/"zlib-dynamic" => "default",/a\ \ "sctp" => "default",' configdata.pm > configdata.pm.new && \
 touch -r configdata.pm configdata.pm.new && \
 mv -f configdata.pm.new configdata.pm)

patch -p1 -R < %{PATCH1031}

%define __provides_exclude_from %{_libdir}/openssl

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}/{%{_bindir},%{_includedir},%{_libdir},%{_mandir},%{_libdir}/openssl,%{_pkgdocdir}}
%make_install
rename so.%{soversion} so.%{version} %{buildroot}/%{_libdir}/*.so.%{soversion}
for lib in %{buildroot}/%{_libdir}/*.so.%{version} ; do
	chmod 0755 ${lib}
	ln -s -f `basename ${lib}` %{buildroot}/%{_libdir}/`basename ${lib} .%{version}`
	ln -s -f `basename ${lib}` %{buildroot}/%{_libdir}/`basename ${lib} .%{version}`.%{soversion}
done

rm -f %{buildroot}/%{_libdir}/*.a || :

pushd %{buildroot}/%{_mandir}
ln -s -f config.5 man5/openssl.cnf.5
for manpage in man*/* ; do
	if [ -L ${manpage} ]; then
		TARGET=`ls -l ${manpage} | awk '{ print $NF }'`
		ln -snf ${TARGET}ssl ${manpage}ssl
		rm -f ${manpage}
	else
		mv ${manpage} ${manpage}ssl
	fi
done
for conflict in passwd rand ; do
	rename ${conflict} ssl${conflict} man*/${conflict}*
	manpage=man1/openssl-${conflict}.*
	if [ -L ${manpage} ] ; then
		ln -snf ssl${conflict}.1ssl ${manpage}
	fi
done
popd

rm -rf  %{buildroot}/%{_mandir}/man[157]*
rm -rf  %{buildroot}/%{_sysconfdir}/pki/*
rm -rf  %{buildroot}/%{_bindir}
rm -f   %{buildroot}/%{_libdir}/engines-1.1/capi.so

basearch=%{_arch}

sed -i '/^\#ifndef OPENSSL_NO_SSL_TRACE/i\
#ifndef OPENSSL_NO_SSL3\
# define OPENSSL_NO_SSL3\
#endif' %{buildroot}/%{_prefix}/include/openssl/opensslconf.h

%if %{without devel}
rm -rf %{buildroot}/%{_includedir}/openssl
rm -rf %{buildroot}/%{_mandir}/man3*
rm -rf %{buildroot}/%{_libdir}/*.so
rm -rf %{buildroot}/%{_libdir}/pkgconfig
%endif

%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%attr(0755,root,root) %{_libdir}/libcrypto.so.%{version}
%attr(0755,root,root) %{_libdir}/libcrypto.so.%{soversion}
%attr(0755,root,root) %{_libdir}/libssl.so.%{version}
%attr(0755,root,root) %{_libdir}/libssl.so.%{soversion}
%attr(0755,root,root) %{_libdir}/engines-%{soversion}

%files devel
%doc CHANGES doc/dir-locals.example.el doc/openssl-c-indent.el
%{_prefix}/include/openssl
%{_libdir}/*.so
%{_mandir}/man3*/*
%{_libdir}/pkgconfig/*.pc

%files doc
%doc FAQ NEWS README README.FIPS

%ldconfig_scriptlets

%changelog
* Thu May 8 2025 Yihao Yan <yan.yihao@zte.com.cn> - 1:1.1.1q-5
- add support for riscv64

* Thu Dec 28 2023 happy_orange <songnannan@linux.alibaba.com> - 1:1.1.1q-4
- fix the source error

* Wed Oct 18 2023 Wenlong Zhang <zhangwenlong@loongson.cn>  - 1:1.1.1q-3
- add loongarch64 support for openssl

* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> -1:1.1.1q-2
- Optimize spec file

* Tue Sep 13 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 1:1.1.1q-1
- init from upstream
